/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Represents the types of precision which can be used when obtaining the value of a cell.
 */
export var Precision = /*@__PURE__*/ (function (Precision) {
    /**
     * The display value of the cell is used. If the cell's actual value is 10.005, but it is using currency formatting,
     * it will display as $10.01.  When this cell is used in calculations, its displayed value of 10.01 will be used.
     */
    Precision[Precision["UseDisplayValues"] = 0] = "UseDisplayValues";
    /**
     * The actual value of the cell is used. If the cell's actual value is 10.005, but it is using currency formatting,
     * it will display as $10.01.  When this cell is used in calculations, its stored value of 10.005 will be used,
     * even though the display shows a slightly different value.
     */
    Precision[Precision["UseRealCellValues"] = 1] = "UseRealCellValues";
    return Precision;
})({});
/**
 * @hidden
 */
export let Precision_$type = markEnum('Precision', 'UseDisplayValues,0|UseRealCellValues,1');
