/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Constants which determine the manner in which series values
 * are used to color regions on a geographic map chart.
 * <p class="body">
 * Applicable only when the associated series [[Series.chartType]] is <i>RegionMap</i>.
 * </p>
 */
export var SeriesValuesColorBy = /*@__PURE__*/ (function (SeriesValuesColorBy) {
    /**
     * The coloring of map regions is determined by the numerical value of the associated data point.
     */
    SeriesValuesColorBy[SeriesValuesColorBy["NumericalValue"] = 0] = "NumericalValue";
    /**
     * The coloring of map regions is determined by the value of the associated data point,
     * which is assumed to represent a category.
     */
    SeriesValuesColorBy[SeriesValuesColorBy["SecondaryCategory"] = 1] = "SecondaryCategory";
    return SeriesValuesColorBy;
})({});
/**
 * @hidden
 */
export let SeriesValuesColorBy_$type = markEnum('SeriesValuesColorBy', 'NumericalValue,0|SecondaryCategory,1');
