/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Determines how the min or max axis is calculated for a
 * @see [[Sparkline]]
 * @see [[SparklineGroup.verticalAxisMaxType]]
 * @see [[SparklineGroup.verticalAxisMinType]]
 */
export var SparklineAxisMinMax = /*@__PURE__*/ (function (SparklineAxisMinMax) {
    /**
     * Specifies that the vertical axis minimum or maximum for each sparkline in this sparkline group is calculated automatically such that the data point with the minimum or maximum value can be displayed in the plot area.
     */
    SparklineAxisMinMax[SparklineAxisMinMax["Individual"] = 0] = "Individual";
    /**
     * Specifies that the vertical axis minimum or maximum is shared across all sparklines in this sparkline group and is calculated automatically such that the data point with the minimum or maximum value can be displayed in the plot area.
     */
    SparklineAxisMinMax[SparklineAxisMinMax["Group"] = 1] = "Group";
    /**
     * Specifies that the vertical axis minimum or maximum for each sparkline in this sparkline group is specified by the [[SparklineGroup.verticalAxisMin]] or the [[SparklineGroup.verticalAxisMax]] attribute of the [[SparklineGroup]].
     */
    SparklineAxisMinMax[SparklineAxisMinMax["Custom"] = 2] = "Custom";
    return SparklineAxisMinMax;
})({});
/**
 * @hidden
 */
export let SparklineAxisMinMax_$type = markEnum('SparklineAxisMinMax', 'Individual,0|Group,1|Custom,2');
