/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Represents the various views for a worksheet.
 */
export var WorksheetView = /*@__PURE__*/ (function (WorksheetView) {
    /**
     * The worksheet is displayed in the normal view.
     */
    WorksheetView[WorksheetView["Normal"] = 0] = "Normal";
    /**
     * The worksheet is displayed as it will appear when printed. This view displays where
     * printed pages will begin and end as well as any headers or footers for the workbook.
     * This value is only supported in Excel 2007 and defaults to Normal in earlier version.
     */
    WorksheetView[WorksheetView["PageLayout"] = 1] = "PageLayout";
    /**
     * This view shows a preview of where pages will break when the worksheet is printed.
     */
    WorksheetView[WorksheetView["PageBreakPreview"] = 2] = "PageBreakPreview";
    return WorksheetView;
})({});
/**
 * @hidden
 */
export let WorksheetView_$type = markEnum('WorksheetView', 'Normal,0|PageLayout,1|PageBreakPreview,2');
