/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Represents the the ways formulas are recalculated when their referenced values change.
 * @see [[Workbook.calculationMode]]
 */
export var CalculationMode = /*@__PURE__*/ (function (CalculationMode) {
    /**
     * Formulas must be recalculated manually, by pressing a button in the Microsoft Excel interface.
     */
    CalculationMode[CalculationMode["Manual"] = 0] = "Manual";
    /**
     * Formulas and data tables are automatically recalculated when the values in referenced cells change.
     */
    CalculationMode[CalculationMode["Automatic"] = 1] = "Automatic";
    /**
     * Only formulas are automatically recalculated when the values in referenced cells change.
     * Data tables must be recalculated manually.
     */
    CalculationMode[CalculationMode["AutomaticExceptForDataTables"] = 2] = "AutomaticExceptForDataTables";
    return CalculationMode;
})({});
/**
 * @hidden
 */
export var CalculationMode_$type = markEnum('CalculationMode', 'Manual,0|Automatic,1|AutomaticExceptForDataTables,2');
