/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Constants which identify whether a [[ColorScaleConditionalFormat]]
 * supports two or three thresholds. Used to differentiate between a 2-color and
 * 3-color scale.
 */
export var ColorScaleType = /*@__PURE__*/ (function (ColorScaleType) {
    /**
     * The color scale supports only the <see cref="ColorScaleConditionalFormat.MinimumThreshold">minimum</see>
     * and <see cref="ColorScaleConditionalFormat.MaximumThreshold">maximum</see> thresholds.
     */
    ColorScaleType[ColorScaleType["TwoColor"] = 0] = "TwoColor";
    /**
     * In addition to the the <see cref="ColorScaleConditionalFormat.MinimumThreshold">minimum</see>
     * and <see cref="ColorScaleConditionalFormat.MaximumThreshold">maximum</see> thresholds, the color
     * scale also supports a <see cref="ColorScaleConditionalFormat.MidpointThreshold">midpoint</see>
     * threshold.
     */
    ColorScaleType[ColorScaleType["ThreeColor"] = 1] = "ThreeColor";
    return ColorScaleType;
})({});
/**
 * @hidden
 */
export var ColorScaleType_$type = markEnum('ColorScaleType', 'TwoColor,0|ThreeColor,1');
