/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Represents the ways shapes will be repositioned when rows and columns are resized.
 */
export var ShapePositioningMode = /*@__PURE__*/ (function (ShapePositioningMode) {
    /**
     * Shapes will move and size with the cells. If columns before (or rows above) the shape are expanded,
     * the shape will shift left. If columns within a shape are expanded, the shape will be widened.
     */
    ShapePositioningMode[ShapePositioningMode["MoveAndSizeWithCells"] = 0] = "MoveAndSizeWithCells";
    /**
     * Shapes will move but not size with the cells. If columns before (or rows above) the shape are
     * expanded, the shape will shift left. If columns within a shape are expanded, the shape will not
     * be widened.
     */
    ShapePositioningMode[ShapePositioningMode["MoveWithCells"] = 2] = "MoveWithCells";
    /**
     * Shapes will not move or size with the cells. The shape will remain in its absolute pixel position of
     * the worksheet, regardless the rows and columns resized before or inside it.
     */
    ShapePositioningMode[ShapePositioningMode["DontMoveOrSizeWithCells"] = 3] = "DontMoveOrSizeWithCells";
    return ShapePositioningMode;
})({});
/**
 * @hidden
 */
export var ShapePositioningMode_$type = markEnum('ShapePositioningMode', 'MoveAndSizeWithCells,0|MoveWithCells,2|DontMoveOrSizeWithCells,3');
