/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { markType } from "igniteui-angular-core";
import { CalcFunctionUtilities } from "./CalcFunctionUtilities";
import { ExcelCalcErrorValue } from "./ExcelCalcErrorValue";
/**
 * @hidden
 */
var UltraCalcFunctionFisher = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionFisher, _super);
    function UltraCalcFunctionFisher() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionFisher.prototype.evaluate = function (a, b) {
        return CalcFunctionUtilities.h(a, true, function (c) {
            if (c <= -1 || c >= 1) {
                return new ExcelCalcValue(new ExcelCalcErrorValue(4));
            }
            var d = Math.log((1 + c) / (1 - c)) / 2;
            return new ExcelCalcValue(d);
        });
    };
    UltraCalcFunctionFisher.prototype.get_name = function () {
        return "fisher";
    };
    Object.defineProperty(UltraCalcFunctionFisher.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionFisher.prototype.get_minArgs = function () {
        return 1;
    };
    Object.defineProperty(UltraCalcFunctionFisher.prototype, "minArgs", {
        get: function () {
            return this.get_minArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionFisher.prototype.get_maxArgs = function () {
        return 1;
    };
    Object.defineProperty(UltraCalcFunctionFisher.prototype, "maxArgs", {
        get: function () {
            return this.get_maxArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionFisher.$t = markType(UltraCalcFunctionFisher, 'UltraCalcFunctionFisher', BuiltInFunctionBase.$);
    return UltraCalcFunctionFisher;
}(BuiltInFunctionBase));
export { UltraCalcFunctionFisher };
