/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Base, markType } from "igniteui-angular-core";
import { IEG_ColorTransformVisitor$2_$type } from "./IEG_ColorTransformVisitor$2";
import { Color } from "igniteui-angular-core";
import { ST_Percentage } from "./ST_Percentage";
import { ST_FixedPercentage } from "./ST_FixedPercentage";
import { Convert } from "igniteui-angular-core";
import { ST_PositivePercentage } from "./ST_PositivePercentage";
import { ST_PositiveFixedPercentage } from "./ST_PositiveFixedPercentage";
import { ExcelUtils } from "./ExcelUtils";
import { MathUtilities } from "./MathUtilities";
import { truncate } from "igniteui-angular-core";
/**
 * @hidden
 */
var XlsxUtilities_ColorTransformsApplicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(XlsxUtilities_ColorTransformsApplicator, _super);
    function XlsxUtilities_ColorTransformsApplicator() {
        return _super.call(this) || this;
    }
    XlsxUtilities_ColorTransformsApplicator.prototype._visitColorTransform_Alpha$i = function (a, b) {
        return XlsxUtilities_ColorTransformsApplicator.c(b, 0, function () { return (ST_PositiveFixedPercentage.m(a.a) / 100) * 255; });
    };
    XlsxUtilities_ColorTransformsApplicator.prototype._visitColorTransform_AlphaMod$i = function (a, b) {
        return XlsxUtilities_ColorTransformsApplicator.c(b, 0, function () { return Convert.toInt32((ST_PositivePercentage.m(a.a) / 100) * b.l); });
    };
    XlsxUtilities_ColorTransformsApplicator.prototype._visitColorTransform_AlphaOff$i = function (a, b) {
        return XlsxUtilities_ColorTransformsApplicator.c(b, 0, function () { return b.l + Convert.toInt32((ST_FixedPercentage.m(a.a) / 100) * 255); });
    };
    XlsxUtilities_ColorTransformsApplicator.prototype._visitColorTransform_Blue$i = function (a, b) {
        return XlsxUtilities_ColorTransformsApplicator.c(b, 3, function () { return (ST_Percentage.l(a.a) / 100) * 255; });
    };
    XlsxUtilities_ColorTransformsApplicator.prototype._visitColorTransform_BlueMod$i = function (a, b) {
        return XlsxUtilities_ColorTransformsApplicator.c(b, 3, function () { return Convert.toInt32((ST_Percentage.l(a.a) / 100) * b.m); });
    };
    XlsxUtilities_ColorTransformsApplicator.prototype._visitColorTransform_BlueOff$i = function (a, b) {
        return XlsxUtilities_ColorTransformsApplicator.c(b, 3, function () { return b.m + Convert.toInt32((ST_Percentage.l(a.a) / 100) * 255); });
    };
    XlsxUtilities_ColorTransformsApplicator.prototype._visitColorTransform_Comp$i = function (a, b) {
        return Color.u(b.l, (255 - b.o), (255 - b.n), (255 - b.m));
    };
    XlsxUtilities_ColorTransformsApplicator.prototype._visitColorTransform_Gray$i = function (a, b) {
        var c = truncate(((b.o * 0.3) + (b.n * 0.59) + (b.m * 0.11)));
        return Color.u(255, c, c, c);
    };
    XlsxUtilities_ColorTransformsApplicator.prototype._visitColorTransform_Green$i = function (a, b) {
        return XlsxUtilities_ColorTransformsApplicator.c(b, 2, function () { return (ST_Percentage.l(a.a) / 100) * 255; });
    };
    XlsxUtilities_ColorTransformsApplicator.prototype._visitColorTransform_GreenMod$i = function (a, b) {
        return XlsxUtilities_ColorTransformsApplicator.c(b, 2, function () { return Convert.toInt32((ST_Percentage.l(a.a) / 100) * b.n); });
    };
    XlsxUtilities_ColorTransformsApplicator.prototype._visitColorTransform_GreenOff$i = function (a, b) {
        return XlsxUtilities_ColorTransformsApplicator.c(b, 2, function () { return b.n + Convert.toInt32((ST_Percentage.l(a.a) / 100) * 255); });
    };
    XlsxUtilities_ColorTransformsApplicator.prototype._visitColorTransform_Hue$i = function (a, b) {
        return XlsxUtilities_ColorTransformsApplicator.b(b, 0, function (c) { return 240 * (a.a.q() / 360); });
    };
    XlsxUtilities_ColorTransformsApplicator.prototype._visitColorTransform_HueMod$i = function (a, b) {
        return XlsxUtilities_ColorTransformsApplicator.b(b, 0, function (c) { return c * (ST_PositivePercentage.m(a.a) / 100); });
    };
    XlsxUtilities_ColorTransformsApplicator.prototype._visitColorTransform_HueOff$i = function (a, b) {
        return XlsxUtilities_ColorTransformsApplicator.b(b, 0, function (c) { return c + 240 * (a.a.n() / 360); });
    };
    XlsxUtilities_ColorTransformsApplicator.prototype._visitColorTransform_Inv$i = function (a, b) {
        return Color.u(b.l, (255 - b.o), (255 - b.n), (255 - b.m));
    };
    XlsxUtilities_ColorTransformsApplicator.prototype._visitColorTransform_Lum$i = function (a, b) {
        return XlsxUtilities_ColorTransformsApplicator.b(b, 2, function (c) { return 240 * (ST_Percentage.l(a.a) / 100); });
    };
    XlsxUtilities_ColorTransformsApplicator.prototype._visitColorTransform_LumMod$i = function (a, b) {
        return XlsxUtilities_ColorTransformsApplicator.b(b, 2, function (c) { return c * (ST_Percentage.l(a.a) / 100); });
    };
    XlsxUtilities_ColorTransformsApplicator.prototype._visitColorTransform_LumOff$i = function (a, b) {
        return XlsxUtilities_ColorTransformsApplicator.b(b, 2, function (c) { return c + (240 * (ST_Percentage.l(a.a) / 100)); });
    };
    XlsxUtilities_ColorTransformsApplicator.prototype._visitColorTransform_Red$i = function (a, b) {
        return XlsxUtilities_ColorTransformsApplicator.c(b, 1, function () { return (ST_Percentage.l(a.a) / 100) * 255; });
    };
    XlsxUtilities_ColorTransformsApplicator.prototype._visitColorTransform_RedMod$i = function (a, b) {
        return XlsxUtilities_ColorTransformsApplicator.c(b, 1, function () { return Convert.toInt32((ST_Percentage.l(a.a) / 100) * b.o); });
    };
    XlsxUtilities_ColorTransformsApplicator.prototype._visitColorTransform_RedOff$i = function (a, b) {
        return XlsxUtilities_ColorTransformsApplicator.c(b, 1, function () { return b.o + Convert.toInt32((ST_Percentage.l(a.a) / 100) * 255); });
    };
    XlsxUtilities_ColorTransformsApplicator.prototype._visitColorTransform_Sat$i = function (a, b) {
        return XlsxUtilities_ColorTransformsApplicator.b(b, 1, function (c) { return 240 * (ST_Percentage.l(a.a) / 100); });
    };
    XlsxUtilities_ColorTransformsApplicator.prototype._visitColorTransform_SatMod$i = function (a, b) {
        return XlsxUtilities_ColorTransformsApplicator.b(b, 1, function (c) { return c * (ST_Percentage.l(a.a) / 100); });
    };
    XlsxUtilities_ColorTransformsApplicator.prototype._visitColorTransform_SatOff$i = function (a, b) {
        return XlsxUtilities_ColorTransformsApplicator.b(b, 1, function (c) { return c + (240 * (ST_Percentage.l(a.a) / 100)); });
    };
    XlsxUtilities_ColorTransformsApplicator.prototype._visitColorTransform_Shade$i = function (a, b) {
        try {
            b = ExcelUtils.gv(b, ST_PositiveFixedPercentage.m(a.a) / 100);
        }
        catch (c) {
        }
        return b;
    };
    XlsxUtilities_ColorTransformsApplicator.prototype._visitColorTransform_Tint$i = function (a, b) {
        try {
            b = ExcelUtils.gw(b, 1 - (ST_PositiveFixedPercentage.m(a.a) / 100));
        }
        catch (c) {
        }
        return b;
    };
    XlsxUtilities_ColorTransformsApplicator.c = function (a, b, c) {
        try {
            var d = truncate(Math.max(0, Math.min(MathUtilities.f(c()), 255)));
            switch (b) {
                default:
                case 0: return Color.u(d, a.o, a.n, a.m);
                case 1: return Color.u(a.l, d, a.n, a.m);
                case 2: return Color.u(a.l, a.o, d, a.m);
                case 3: return Color.u(a.l, a.o, a.n, d);
            }
        }
        catch (e) {
            return a;
        }
    };
    XlsxUtilities_ColorTransformsApplicator.b = function (a, b, c) {
        try {
            var d = void 0, e = void 0, f = void 0;
            var g = ExcelUtils.fa(a, d, f, e);
            d = g.p1;
            f = g.p2;
            e = g.p3;
            var h = void 0;
            switch (b) {
                default:
                case 0:
                    h = d;
                    break;
                case 1:
                    h = e;
                    break;
                case 2:
                    h = f;
                    break;
            }
            var i = truncate(Math.max(0, Math.min(MathUtilities.f(c(h)), 240)));
            switch (b) {
                default:
                case 0: return ExcelUtils.g0(i, f, e);
                case 2: return ExcelUtils.g0(d, i, e);
                case 1: return ExcelUtils.g0(d, f, i);
            }
        }
        catch (j) {
            return a;
        }
    };
    XlsxUtilities_ColorTransformsApplicator.$t = markType(XlsxUtilities_ColorTransformsApplicator, 'XlsxUtilities_ColorTransformsApplicator', Base.$, [IEG_ColorTransformVisitor$2_$type.specialize(Color.$, Color.$)]);
    XlsxUtilities_ColorTransformsApplicator.a = new XlsxUtilities_ColorTransformsApplicator();
    return XlsxUtilities_ColorTransformsApplicator;
}(Base));
export { XlsxUtilities_ColorTransformsApplicator };
