import { Type } from "igniteui-angular-core";
/**
 * Constants which describe the point at which
 * <see cref="Axis">axes</see> intersect.
 */
export declare enum AxisCrosses {
    /**
     * The crossing point is determined automatically.
     */
    Automatic = -4105,
    /**
     * A custom value is designated as the crossing point, using the
     * [[Axis.crossesAt]] property
     */
    Custom = -4114,
    /**
     * The axes cross at the point coinciding with the axis' maximum value.
     */
    Maximum = 2,
    /**
     * The axes cross at the point coinciding with the axis' minimum value.
     */
    Minimum = 4
}
/**
 * @hidden
 */
export declare let AxisCrosses_$type: Type;
