import { Type } from "igniteui-angular-core";
/**
 * Constants which define the shape used by a bar chart series.
 */
export declare enum BarShape {
    /**
     * Square box
     */
    Box = 0,
    /**
     * Pyramid-shaped bar extending to the series maximum.
     */
    PyramidToPoint = 1,
    /**
     * Truncated pyramid-shaped bar.
     */
    PyramidToMax = 2,
    /**
     * Cylinder shaped bar.
     */
    Cylinder = 3,
    /**
     * Cone-shaped bar extending to the series maximum.
     */
    ConeToPoint = 4,
    /**
     * Truncated cone-shaped bar.
     */
    ConeToMax = 5
}
/**
 * @hidden
 */
export declare let BarShape_$type: Type;
