import { Type } from "igniteui-angular-core";
/**
 * Represents the the ways formulas are recalculated when their referenced values change.
 * @see [[Workbook.calculationMode]]
 */
export declare enum CalculationMode {
    /**
     * Formulas must be recalculated manually, by pressing a button in the Microsoft Excel interface.
     */
    Manual = 0,
    /**
     * Formulas and data tables are automatically recalculated when the values in referenced cells change.
     */
    Automatic = 1,
    /**
     * Only formulas are automatically recalculated when the values in referenced cells change.
     * Data tables must be recalculated manually.
     */
    AutomaticExceptForDataTables = 2
}
/**
 * @hidden
 */
export declare let CalculationMode_$type: Type;
