import { Type } from "igniteui-angular-core";
/**
 * Represents the different cell border line styles.
 */
export declare enum CellBorderLineStyle {
    /**
     * Use the default border line style.
     */
    Default = -1,
    /**
     * No border.
     */
    None = 0,
    /**
     * Thin border.
     */
    Thin = 1,
    /**
     * Medium border.
     */
    Medium = 2,
    /**
     * Dashed border.
     */
    Dashed = 3,
    /**
     * Dotted border.
     */
    Dotted = 4,
    /**
     * Thick border.
     */
    Thick = 5,
    /**
     * Double-line border.
     */
    double1 = 6,
    /**
     * Dotted border with small dots.
     */
    Hair = 7,
    /**
     * Dotted border with big dots.
     */
    MediumDashed = 8,
    /**
     * Dash-dot border.
     */
    DashDot = 9,
    /**
     * Medium dash-dot border.
     */
    MediumDashDot = 10,
    /**
     * Dash-dot-dot border.
     */
    DashDotDot = 11,
    /**
     * Medium dash-dot-dot border.
     */
    MediumDashDotDot = 12,
    /**
     * Slanted dash-dot border.
     */
    SlantedDashDot = 13
}
/**
 * @hidden
 */
export declare let CellBorderLineStyle_$type: Type;
