import { Type } from "igniteui-angular-core";
/**
 * Represents the various logical operators used to combine the conditions of the [[CustomFilter]].
 * @see [[CustomFilter.conditionalOperator]]
 */
export declare enum ConditionalOperator {
    /**
     * Filter in values where only [[CustomFilter.condition1]] and [[CustomFilter.condition2]] pass.
     */
    And = 0,
    /**
     * Filter in values where either [[CustomFilter.condition1]] or [[CustomFilter.condition2]] (or both) pass.
     */
    Or = 1
}
/**
 * @hidden
 */
export declare let ConditionalOperator_$type: Type;
