import { Type } from "igniteui-angular-core";
/**
 * Constants which determine the axis position for a [[DataBarConditionalFormat]].
 */
export declare enum DataBarAxisPosition {
    /**
     * Displays the axis at a variable position based on the ratio of the minimum
     * negative value to the maximum positive value in the associated range. Positive
     * values are displayed in a left-to-right direction; negative values are displayed
     * from right to left. When all values are positive, or all values are negative,
     * no axis is displayed.
     */
    Automatic = 0,
    /**
     * Displays the axis at the midpoint of the cell, regardless of the set of values
     * in the associated range. Positive values are displayed in a left-to-right
     * direction; negative values are displayed from right to left.
     */
    Midpoint = 1,
    /**
     * No axis is displayed; positive and negative values are both displayed in
     * the left-to-right direction.
     */
    None = 2
}
/**
 * @hidden
 */
export declare let DataBarAxisPosition_$type: Type;
