import { Type } from "igniteui-angular-core";
/**
 * Constants which determine whether <see cref="DataBarConditionalFormat">data bars</see> are filled with a solid color or
 * with a gradient.
 */
export declare enum DataBarDirection {
    /**
     * The direction the data bar is displayed is based on context.
     */
    Context = -5002,
    /**
     * The data bar is displayed from left-to-right.
     */
    LeftToRight = -5003,
    /**
     * The data bar is displayed from right-to-left.
     */
    RightToLeft = -5004
}
/**
 * @hidden
 */
export declare let DataBarDirection_$type: Type;
