import { Type } from "igniteui-angular-core";
/**
 * Represents the various types, or precisions, of a [[FixedDateGroup]].
 * @see [[FixedDateGroup.type]]
 */
export declare enum FixedDateGroupType {
    /**
     * The group represents the day in which the [[FixedDateGroup.value]] exists.
     */
    Day = 0,
    /**
     * The group represents the hour in which the [[FixedDateGroup.value]] exists.
     */
    Hour = 1,
    /**
     * The group represents the minute in which the [[FixedDateGroup.value]] exists.
     */
    Minute = 2,
    /**
     * The group represents the month in which the [[FixedDateGroup.value]] exists.
     */
    Month = 3,
    /**
     * The group represents the second in which the [[FixedDateGroup.value]] exists.
     */
    Second = 4,
    /**
     * The group represents the year in which the [[FixedDateGroup.value]] exists.
     */
    Year = 5
}
/**
 * @hidden
 */
export declare let FixedDateGroupType_$type: Type;
