import { Type } from "igniteui-angular-core";
/**
 * Enumeration for font underline styles. Default value is used in property override situations.
 */
export declare enum FontUnderlineStyle {
    /**
     * Use the current default.
     */
    Default = -1,
    /**
     * No underline style.
     */
    None = 0,
    /**
     * Single underline style.
     */
    Single = 1,
    /**
     * Double underline style.
     */
    double1 = 2,
    /**
     * Single accounting underline style.
     */
    SingleAccounting = 33,
    /**
     * Double accounting underline style.
     */
    DoubleAccounting = 34
}
/**
 * @hidden
 */
export declare let FontUnderlineStyle_$type: Type;
