import { Type } from "igniteui-angular-core";
/**
 * Constants which specify the manner in which cell values are compared
 * when evaluating a [[AverageConditionalFormat]].
 */
export declare enum FormatConditionAboveBelow {
    /**
     * The cell value must be above the average for the associated range
     * in order to meet the associated condition.
     */
    AboveAverage = 0,
    /**
     * The cell value must be below the average for the associated range
     * in order to meet the associated condition.
     */
    BelowAverage = 1,
    /**
     * The cell value must be equal to or above the average for the associated range
     * in order to meet the associated condition.
     */
    EqualAboveAverage = 2,
    /**
     * The cell value must be equal to or below the average for the associated range
     * in order to meet the associated condition.
     */
    EqualBelowAverage = 3,
    /**
     * The cell value must be above the standard deviation for the associated range
     * in order to meet the associated condition.
     */
    AboveStandardDeviation = 4,
    /**
     * The cell value must be below the standard deviation for the associated range
     * in order to meet the associated condition.
     */
    BelowStandardDeviation = 5
}
/**
 * @hidden
 */
export declare let FormatConditionAboveBelow_$type: Type;
