import { Type } from "igniteui-angular-core";
/**
 * Constants which specify the text comparison method applied when
 * evaluating a <see cref="ConditionalFormatBase">format condition</see>.
 */
export declare enum FormatConditionTextOperator {
    /**
     * The string being evaluated must begin with the value to which
     * it is being compared in order for the condition to be met.
     */
    BeginsWith = 0,
    /**
     * The string being evaluated must end with the value to which
     * it is being compared in order for the condition to be met.
     */
    EndsWith = 1,
    /**
     * The string being evaluated must match some part of the value to which
     * it is being compared in order for the condition to be met.
     */
    Contains = 2,
    /**
     * Negates the [[FormatConditionTextOperator.contains]] value; the string being evaluated
     * must not match any part of the value to which it is being compared in
     * order for the condition to be met.
     */
    DoesNotContain = 3
}
/**
 * @hidden
 */
export declare let FormatConditionTextOperator_$type: Type;
