import { Type } from "igniteui-angular-core";
/**
 * Constants which define the projection for a geographic map chart.
 */
export declare enum GeographicMapProjection {
    /**
     * Albers equal-area conic projection.
     */
    Albers = 0,
    /**
     * Mercator cylindrical map projection.
     */
    Mercator = 1,
    /**
     * Miller cylindrical map projection.
     */
    Miller = 2,
    /**
     * Robinson flat map projection.
     */
    Robinson = 3
}
/**
 * @hidden
 */
export declare let GeographicMapProjection_$type: Type;
