import { Type } from "igniteui-angular-core";
/**
 * Constants which determine the type of gradient applied to a
 * [[ChartGradientFill]].
 */
export declare enum GradientType {
    /**
     * The gradient extends in a linear direction.
     */
    Linear = 0,
    /**
     * The gradient extends along a radial curve.
     */
    Radial = 1,
    /**
     * The gradient extends along a rectangular path.
     */
    Rectangular = 2,
    /**
     * The gradient direction is determined by the shape's path.
     */
    Path = 3
}
/**
 * @hidden
 */
export declare let GradientType_$type: Type;
