import { Type } from "igniteui-angular-core";
/**
 * Represents the ways to order the pages of multiple page worksheets.
 */
export declare enum PageOrder {
    /**
     * The first page to print is the top-left page. The next pages printed are below the first page.
     * When there are no more pages below, the page to the right of the top-left page is printed, then the pages
     * below it, and so on.
     */
    DownThenOver = 0,
    /**
     * The first page to print is the top-left page. The next pages printed are right of the first page.
     * When there are no more pages to the right, the page below the top-left page is printed, then the pages
     * to the right of it, and so on.
     */
    OverThenDown = 1
}
/**
 * @hidden
 */
export declare let PageOrder_$type: Type;
