import { Type } from "igniteui-angular-core";
/**
 * Constants which determine the manner in which a picture is displayed.
 */
export declare enum PictureType {
    /**
     * The picture is stretched to fill it's containing element.
     */
    Stretch = 1,
    /**
     * The picture is stacked or tiled to fill it's containing element.
     */
    Stack = 2,
    /**
     * The picture is scaled to fill it's containing element.
     */
    Scale = 3
}
/**
 * @hidden
 */
export declare let PictureType_$type: Type;
