import { Type } from "igniteui-angular-core";
/**
 * Represents the options available for getting or setting the bounds of a shape, cell, or region.
 */
export declare enum PositioningOptions {
    /**
     * No special options should be used. Get and set actual bounds on the worksheet in its current state.
     */
    None = 0,
    /**
     * Ignore the [[RowColumnBase.hidden]] value on all rows and columns.
     * Get and set bounds as if all rows and columns were currently visible.
     */
    TreatAllRowsAndColumnsAsVisible = 1
}
/**
 * @hidden
 */
export declare let PositioningOptions_$type: Type;
