import { Type } from "igniteui-angular-core";
/**
 * Represents the types of precision which can be used when obtaining the value of a cell.
 */
export declare enum Precision {
    /**
     * The display value of the cell is used. If the cell's actual value is 10.005, but it is using currency formatting,
     * it will display as $10.01.  When this cell is used in calculations, its displayed value of 10.01 will be used.
     */
    UseDisplayValues = 0,
    /**
     * The actual value of the cell is used. If the cell's actual value is 10.005, but it is using currency formatting,
     * it will display as $10.01.  When this cell is used in calculations, its stored value of 10.005 will be used,
     * even though the display shows a slightly different value.
     */
    UseRealCellValues = 1
}
/**
 * @hidden
 */
export declare let Precision_$type: Type;
