import { Type } from "igniteui-angular-core";
/**
 * Represents the various ways to print cell errors in a worksheet.
 */
export declare enum PrintErrors {
    /**
     * Errors are printed just as they are displayed on the worksheet.
     */
    PrintAsDisplayed = 0,
    /**
     * Errors are not prints, as though the cells containing them have no value.
     */
    DontPrint = 1,
    /**
     * Errors are printed as two dashes "--".
     */
    PrintAsDashes = 2,
    /**
     * Errors are prints as "#N/A".
     */
    PrintAsNA = 3
}
/**
 * @hidden
 */
export declare let PrintErrors_$type: Type;
