import { Type } from "igniteui-angular-core";
/**
 * Constants which determine the method of calculation
 * used when determining the median for a box and whisker chart.
 */
export declare enum QuartileCalculation {
    /**
     * The median is included in the calculation if <i>n</i> (the number of values in the data) is odd.
     */
    InclusiveMedian = 0,
    /**
     * The median is excluded from the calculation if <i>n</i> (the number of values in the data) is odd.
     */
    ExclusiveMedian = 1
}
/**
 * @hidden
 */
export declare let QuartileCalculation_$type: Type;
