import { Type } from "igniteui-angular-core";
/**
 * Represents the ways to scale a worksheet when it is printed.
 */
export declare enum ScalingType {
    /**
     * The scaling factor is used to scale the worksheet when printing.
     */
    UseScalingFactor = 0,
    /**
     * The page maximums are used to determine how many pages the worksheet can be printed on.
     * Less pages can be used if there is not enough printable content in the worksheet.
     */
    FitToPages = 1
}
/**
 * @hidden
 */
export declare let ScalingType_$type: Type;
