import { Type } from "igniteui-angular-core";
/**
 * Determines the type of [[Series]].
 */
export declare enum SeriesType {
    /**
     * Area; used by both area and area 3D charts.
     */
    Area = 0,
    /**
     * Bar; used by both bar and bar 3D charts.
     */
    Bar = 1,
    /**
     * Line; used by line, line 3D, and stock charts.
     */
    Line = 2,
    /**
     * Pie; used by pie, pie 3D, doughnut, and 'of pie' charts.
     */
    Pie = 3,
    /**
     * Radar.
     */
    Radar = 4,
    /**
     * Surface; used by surface and surface 3D charts.
     */
    Surface = 5,
    /**
     * Scatter.
     */
    Scatter = 6,
    /**
     * Bubble.
     */
    Bubble = 7
}
/**
 * @hidden
 */
export declare let SeriesType_$type: Type;
