import { Type } from "igniteui-angular-core";
/**
 * Represents the ways shapes will be repositioned when rows and columns are resized.
 */
export declare enum ShapePositioningMode {
    /**
     * Shapes will move and size with the cells. If columns before (or rows above) the shape are expanded,
     * the shape will shift left. If columns within a shape are expanded, the shape will be widened.
     */
    MoveAndSizeWithCells = 0,
    /**
     * Shapes will move but not size with the cells. If columns before (or rows above) the shape are
     * expanded, the shape will shift left. If columns within a shape are expanded, the shape will not
     * be widened.
     */
    MoveWithCells = 2,
    /**
     * Shapes will not move or size with the cells. The shape will remain in its absolute pixel position of
     * the worksheet, regardless the rows and columns resized before or inside it.
     */
    DontMoveOrSizeWithCells = 3
}
/**
 * @hidden
 */
export declare let ShapePositioningMode_$type: Type;
