import { Type } from "igniteui-angular-core";
/**
 * Represents the various way to combine a cell's value and format string to get its text.
 * @see [[WorksheetCell.getText]]
 * @see [[WorksheetCell.getText]]
 * @see [[WorksheetRow.getCellText]]
 * @see [[WorksheetRow.getCellText]]
 */
export declare enum TextFormatMode {
    /**
     * Format the cell text as it is displayed in the Microsoft Excel UI. This takes into account the cell width when
     * formatting the text.
     */
    AsDisplayed = 0,
    /**
     * Format the cell text as if it had unlimited space in the cell. However, this will not include padding characters
     * from the format string.
     */
    IgnoreCellWidth = 1
}
/**
 * @hidden
 */
export declare let TextFormatMode_$type: Type;
