import { Type } from "igniteui-angular-core";
/**
 * Constants which describe whether text is allowed to continue
 * vertically outside the bounds of the containing element.
 */
export declare enum TextVerticalOverflow {
    /**
     * The text is clipped by the containing element.
     */
    Clip = 0,
    /**
     * The text is allowed to continue outside the bounds
     * of the containing element.
     */
    Overflow = 1,
    /**
     * Overflowing text is truncated and an ellipsis is displayed.
     */
    Ellipsis = 2
}
/**
 * @hidden
 */
export declare let TextVerticalOverflow_$type: Type;
