import { Type } from "igniteui-angular-core";
/**
 * Constants which determine the placement of an axis' <see cref="Axis.MajorTickMark">major</see>
 * and <see cref="Axis.MinorTickMark">minor</see> tick marks.
 */
export declare enum TickMark {
    /**
     * The tick marks cross the axis line.
     */
    Cross = 4,
    /**
     * The tick marks appear on the side of the axis line
     * closest to the inside of the plot area.
     */
    Inside = 2,
    /**
     * Tick marks are not displayed.
     */
    None = 4142,
    /**
     * The tick marks appear on the side of the axis line
     * closest to the outside of the plot area.
     */
    Outside = 3
}
/**
 * @hidden
 */
export declare let TickMark_$type: Type;
