import { Type } from "igniteui-angular-core";
/**
 * Represents the various filter types available for the [[TopOrBottomFilter]].
 * @see [[TopOrBottomFilter.type]]
 */
export declare enum TopOrBottomFilterType {
    /**
     * Filter in the top N values in the sorted list of values.
     */
    TopValues = 0,
    /**
     * Filter in the bottom N values in the sorted list of values.
     */
    BottomValues = 1,
    /**
     * Filter in the top N percent of values the sorted list of values.
     */
    TopPercentage = 2,
    /**
     * Filter in the bottom N percent of values the sorted list of values.
     */
    BottomPercentage = 3
}
/**
 * @hidden
 */
export declare let TopOrBottomFilterType_$type: Type;
