import { Type } from "igniteui-angular-core";
/**
 * Constants which define the order/degree of the polynomial
 * applied to a [[Trendline]] when the trendline
 * type is <i>Polynomial</i>.
 * @see [[TrendlineType]]
 */
export declare enum TrendlinePolynomialOrder {
    /**
     * A second-order/degree polynomial.
     */
    Second = 2,
    /**
     * A third-order/degree polynomial.
     */
    Third = 3,
    /**
     * A fourth-order/degree polynomial.
     */
    Fourth = 4,
    /**
     * A fifth-order/degree polynomial.
     */
    Fifth = 5,
    /**
     * A sixth-order/degree polynomial.
     */
    Sixth = 6
}
/**
 * @hidden
 */
export declare let TrendlinePolynomialOrder_$type: Type;
