import { Type } from "igniteui-angular-core";
/**
 * Constants which define the various types of trendlines
 * supported by a [[WorksheetChart]].
 */
export declare enum TrendlineType {
    /**
     * The trendline is exponential.
     */
    Exponential = 0,
    /**
     * The trendline is linear.
     */
    Linear = 1,
    /**
     * The trendline is logarithmic.
     */
    Logarithmic = 2,
    /**
     * The trendline depicts a moving average.
     */
    MovingAverage = 3,
    /**
     * The trendline depicts a polynomial of order/degree <i>n</i>,
     * when <i>n</i> is specified by the ChartTrendline.PolynomialOrder
     * property.
     */
    Polynomial = 4,
    /**
     * The trendline depicts a power curve.
     */
    Power = 5
}
/**
 * @hidden
 */
export declare let TrendlineType_$type: Type;
