import { Type } from "igniteui-angular-core";
/**
 * Represents the various operators which can be used when validating the cell value against two constraints.
 * @see [[TwoConstraintDataValidationRule]]
 * @see [[TwoConstraintDataValidationRule.setLowerConstraint]]
 * @see [[TwoConstraintDataValidationRule.setLowerConstraint]]
 * @see [[TwoConstraintDataValidationRule.setUpperConstraint]]
 * @see [[TwoConstraintDataValidationRule.setUpperConstraint]]
 * @see [[TwoConstraintDataValidationRule.getLowerConstraintFormula]]
 * @see [[TwoConstraintDataValidationRule.getLowerConstraintFormula]]
 * @see [[TwoConstraintDataValidationRule.setLowerConstraintFormula]]
 * @see [[TwoConstraintDataValidationRule.setLowerConstraintFormula]]
 * @see [[TwoConstraintDataValidationRule.getUpperConstraintFormula]]
 * @see [[TwoConstraintDataValidationRule.getUpperConstraintFormula]]
 * @see [[TwoConstraintDataValidationRule.setUpperConstraintFormula]]
 * @see [[TwoConstraintDataValidationRule.setUpperConstraintFormula]]
 * @see [[ValueConstraintDataValidationRule.validationCriteria]]
 */
export declare enum TwoConstraintDataValidationOperator {
    /**
     * Only allows the cell value if it or its text length, depending on the validation criteria, is between the
     * constraints applied to the validation rule. The constraints are inclusive.
     */
    Between = 0,
    /**
     * Only allows the cell value if it or its text length, depending on the validation criteria, is not between the
     * constraints applied to the validation rule. The constraints are exclusive.
     */
    NotBetween = 1
}
/**
 * @hidden
 */
export declare let TwoConstraintDataValidationOperator_$type: Type;
