import { Type } from "igniteui-angular-core";
/**
 * Enumeration for vertical alignment styles. Default value is used in property override situations.
 */
export declare enum VerticalCellAlignment {
    /**
     * Use the current default.
     */
    Default = -1,
    /**
     * Top alignment.
     */
    Top = 0,
    /**
     * Center alignment.
     */
    Center = 1,
    /**
     * Bottom alignment.
     */
    Bottom = 2,
    /**
     * Justify alignment.
     */
    Justify = 3,
    /**
     * Distributed alignment.
     */
    Distributed = 4
}
/**
 * @hidden
 */
export declare let VerticalCellAlignment_$type: Type;
