import { Type } from "igniteui-angular-core";
/**
 * Represents the various file formats in which a workbook can be saved.
 */
export declare enum WorkbookFormat {
    /**
     * The Excel 97-2003 BIFF8 file format.
     */
    Excel97To2003 = 0,
    /**
     * The Excel 97-2003 Template BIFF8 file format.
     */
    Excel97To2003Template = 1,
    /**
     * The Excel 2007 XML file format.
     */
    Excel2007 = 2,
    /**
     * The Excel 2007 Macro-Enabled XML file format.
     */
    Excel2007MacroEnabled = 3,
    /**
     * The Excel 2007 Macro-Enabled Template XML file format.
     */
    Excel2007MacroEnabledTemplate = 4,
    /**
     * The Excel 2007 Template XML file format.
     */
    Excel2007Template = 5,
    /**
     * The Strict Open XML file format (ISO/IEC 29500 Strict).
     */
    StrictOpenXml = 6
}
/**
 * @hidden
 */
export declare let WorkbookFormat_$type: Type;
