import { Type } from "igniteui-angular-core";
/**
 * Represents the various theme colors in a workbook.
 * @see [[WorkbookColorInfo.themeColorType]]
 */
export declare enum WorkbookThemeColorType {
    /**
     * Represents the Text/Background - Light 1 theme color.
     */
    Light1 = 0,
    /**
     * Represents the Text/Background - Dark 1 theme color.
     */
    Dark1 = 1,
    /**
     * Represents the Text/Background - Light 2 theme color.
     */
    Light2 = 2,
    /**
     * Represents the Text/Background - Dark 2 theme color.
     */
    Dark2 = 3,
    /**
     * Represents the Accent 1 theme color.
     */
    Accent1 = 4,
    /**
     * Represents the Accent 2 theme color.
     */
    Accent2 = 5,
    /**
     * Represents the Accent 3 theme color.
     */
    Accent3 = 6,
    /**
     * Represents the Accent 4 theme color.
     */
    Accent4 = 7,
    /**
     * Represents the Accent 5 theme color.
     */
    Accent5 = 8,
    /**
     * Represents the Accent 6 theme color.
     */
    Accent6 = 9,
    /**
     * Represents the Hyperlink theme color.
     */
    Hyperlink = 10,
    /**
     * Represents the Followed Hyperlink theme color.
     */
    FollowedHyperlink = 11
}
/**
 * @hidden
 */
export declare let WorkbookThemeColorType_$type: Type;
