import { Type } from "igniteui-angular-core";
/**
 * Enumeration used to indicate which cells may be selected when the Worksheet is protected.
 * @see [[WorksheetProtection.selectionMode]]
 */
export declare enum WorksheetProtectedSelectionMode {
    /**
     * All cells including locked cells may be selected.
     */
    AllCells = 0,
    /**
     * Only cells that are unlocked may be selected via the keyboard or mouse. Note a cell that is locked may be selected if a range selection is created between 2 unlocked cells.
     */
    UnlockedCells = 1,
    /**
     * The selection cannot be change.
     */
    NoCells = 2
}
/**
 * @hidden
 */
export declare let WorksheetProtectedSelectionMode_$type: Type;
