import { Type } from "igniteui-angular-core";
/**
 * Represents the various views for a worksheet.
 */
export declare enum WorksheetView {
    /**
     * The worksheet is displayed in the normal view.
     */
    Normal = 0,
    /**
     * The worksheet is displayed as it will appear when printed. This view displays where
     * printed pages will begin and end as well as any headers or footers for the workbook.
     * This value is only supported in Excel 2007 and defaults to Normal in earlier version.
     */
    PageLayout = 1,
    /**
     * This view shows a preview of where pages will break when the worksheet is printed.
     */
    PageBreakPreview = 2
}
/**
 * @hidden
 */
export declare let WorksheetView_$type: Type;
